<template>
  <base-layout>
    <template #sidebar-content>
      <v-list dense>
        <v-list-item
          v-for="(item, i) in generalNavItems"
          :key="i"
          exact
          :to="item.route"
        >
          <v-list-item-action>
            <v-icon>{{ item.icon }}</v-icon>
          </v-list-item-action>
          <v-list-item-content>
            <v-list-item-title>
              {{ item.name }}
            </v-list-item-title>
          </v-list-item-content>
        </v-list-item>

        <v-divider />

        <exam-information
          v-if="!mini"
          :exam="exam"
          class="elevation-1 exam-info ma-1"
        />
        <v-list-item
          v-for="item in submissionNavItems"
          :key="item.route"
          exact
          :to="item.route"
        >
          <v-list-item-action>
            <v-icon v-if="!visited[item.id]">
              assignment
            </v-icon>
            <v-icon v-else>
              check
            </v-icon>
          </v-list-item-action>
          <v-list-item-content>
            <v-list-item-title>
              {{ item.name }}
            </v-list-item-title>
          </v-list-item-content>
        </v-list-item>
      </v-list>
    </template>
  </base-layout>
</template>

<script>
import { UI } from '@/store/modules/ui'
import BaseLayout from '@/components/BaseLayout'
import ExamInformation from '@/components/student/ExamInformation'
import { StudentPage } from '@/store/modules/student-page'
export default {
  name: 'StudentLayout',
  components: { BaseLayout, ExamInformation },
  data () {
    return {
      generalNavItems: [
        {
          name: 'Overview',
          icon: 'home',
          route: '/home'
        }
      ]
    }
  },
  computed: {
    submissions () { return StudentPage.state.submissionsForList },
    exam () { return StudentPage.state.exam },
    visited () { return StudentPage.state.visited },
    moduleReference () { return this.exam ? this.exam.moduleReference : 'No exam information' },

    mini () { return UI.state.sideBarCollapsed },

    submissionNavItems () {
      return this.submissions.map((sub, index) => {
        return {
          name: sub.type.name,
          id: sub.type.pk,
          route: `/submission/${sub.type.pk}`
        }
      })
    }
  }
}
</script>

<style scoped>

</style>
